<?php
class Post_Cronjob
{
  public static function init()
  {
    add_filter('cron_schedules', array(__CLASS__, 'add_weekly'));

    add_action('post_location_update', array(__CLASS__, 'generate_locations_file'));

    register_activation_hook(WP_PLUGIN_DIR . '/' . POST_BASENAME, array(__CLASS__, 'activation'));
    register_deactivation_hook(WP_PLUGIN_DIR . '/' . POST_BASENAME, array(__CLASS__, 'deactivation'));
  }

  public static function activation()
  {
    if ( ! wp_next_scheduled('post_location_update')) {
      wp_schedule_event(time(), 'daily', 'post_location_update');
    }
  }

  public static function deactivation()
  {
    wp_clear_scheduled_hook('post_location_update');
  }

  public static function add_weekly($schedules)
  {
    $schedules['daily'] = array(
      'interval' => 86400,
      'display' => __('Once daily', 'post'),
    );
    return $schedules;
  }

  public static function generate_locations_file()
  {
    self::log('Preparing locations update...', true, true);
    $location_params = Post_Core::get_configs('locations');
    if ( empty($location_params['source_url']) ) {
      self::log('Empty source URL.', false);
      return;
    }
    
    $url = $location_params['source_url'];
    $fp = fopen(POST_DIR . "locations_new.json", "w");
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_HEADER, false);
    curl_setopt($curl, CURLOPT_FILE, $fp);
    curl_setopt($curl, CURLOPT_TIMEOUT, 60);
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    $data = curl_exec($curl);
    curl_close($curl);
    fclose($fp);

    $new_data = file_get_contents(POST_DIR . "locations_new.json");
    if ( json_decode($new_data) ) {
      rename(POST_DIR . "locations_new.json", POST_DIR . "locations.json");
      self::log('Locations updated.', false);
    } else {
      self::log('Failed.', false);
    }
    self::log('Preparing locations update...', true, true);
    $location_params_lt = Post_Core::get_configs('locations_lt');
    if ( empty($location_params_lt['source_url']) ) {
      self::log('Empty source URL.', false);
      return;
    }
    
    $url_lt = $location_params_lt['source_url'];
    $fp_lt = fopen(POST_DIR . "locations_new_lt.json", "w");
    $curl_lt = curl_init();
    curl_setopt($curl_lt, CURLOPT_URL, $url_lt);
    curl_setopt($curl_lt, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl_lt, CURLOPT_HEADER, false);
    curl_setopt($curl_lt, CURLOPT_FILE, $fp_lt);
    curl_setopt($curl_lt, CURLOPT_TIMEOUT, 60);
    curl_setopt($curl_lt, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($curl_lt, CURLOPT_SSL_VERIFYPEER, false);
    $data_lt = curl_exec($curl_lt);
    curl_close($curl_lt);
    fclose($fp_lt);

    $new_data_lt = file_get_contents(POST_DIR . "locations_new_lt.json");
    if ( json_decode($new_data_lt) ) {
      rename(POST_DIR . "locations_new_lt.json", POST_DIR . "locations_lt.json");
      self::log('Locations updated.', false);
    } else {
      self::log('Failed.', false);
    }
    self::log('Preparing locations update...', true, true);
    $office_locations_params = Post_Core::get_configs('office_locations');
    if ( empty($office_locations_params['source_url']) ) {
      self::log('Empty source URL.', false);
      return;
    }
    
    $url_office = $office_locations_params['source_url'];
    $fp_office = fopen(POST_DIR . "office_new.json", "w");
    $curl_office = curl_init();
    curl_setopt($curl_office, CURLOPT_URL, $url_office);
    curl_setopt($curl_office, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl_office, CURLOPT_HEADER, false);
    curl_setopt($curl_office, CURLOPT_FILE, $fp_office);
    curl_setopt($curl_office, CURLOPT_TIMEOUT, 60);
    curl_setopt($curl_office, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($curl_office, CURLOPT_SSL_VERIFYPEER, false);
    $data_office = curl_exec($curl_office);
    curl_close($curl_office);
    fclose($fp_office);

    $new_data_office = file_get_contents(POST_DIR . "office_new.json");
    if ( json_decode($new_data_office) ) {
      rename(POST_DIR . "office_new.json", POST_DIR . "locations_office.json");
      self::log('Locations updated.', false);
    } else {
      self::log('Failed.', false);
    }
    self::log('Preparing locations update...', true, true);
    $office_locations_params_lt = Post_Core::get_configs('office_locations_lt');
    if ( empty($office_locations_params_lt['source_url']) ) {
      self::log('Empty source URL.', false);
      return;
    }
    
    $url_office_lt = $office_locations_params_lt['source_url'];
    $fp_office_lt = fopen(POST_DIR . "office_new_lt.json", "w");
    $curl_office_lt = curl_init();
    curl_setopt($curl_office_lt, CURLOPT_URL, $url_office_lt);
    curl_setopt($curl_office_lt, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl_office_lt, CURLOPT_HEADER, false);
    curl_setopt($curl_office_lt, CURLOPT_FILE, $fp_office_lt);
    curl_setopt($curl_office_lt, CURLOPT_TIMEOUT, 60);
    curl_setopt($curl_office_lt, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($curl_office_lt, CURLOPT_SSL_VERIFYPEER, false);
    $data_office_lt = curl_exec($curl_office_lt);
    curl_close($curl_office_lt);
    fclose($fp_office_lt);

    $new_data_office_lt = file_get_contents(POST_DIR . "office_new_lt.json");
    if ( json_decode($new_data_office_lt) ) {
      rename(POST_DIR . "office_new_lt.json", POST_DIR . "locations_office_lt.json");
      self::log('Locations updated.', false);
    } else {
      self::log('Failed.', false);
    }
    self::log('Preparing locations update...', true, true);
    $circle_location_params = Post_Core::get_configs('circle_locations');
    if ( empty($circle_location_params['source_url']) ) {
      self::log('Empty source URL.', false);
      return;
    }
    
    $url_circle = $circle_location_params['source_url'];
    $fp_circle = fopen(POST_DIR . "circle_locations_new.json", "w");
    $curl_circle = curl_init();
    curl_setopt($curl_circle, CURLOPT_URL, $url_circle);
    curl_setopt($curl_circle, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl_circle, CURLOPT_HEADER, false);
    curl_setopt($curl_circle, CURLOPT_FILE, $fp_circle);
    curl_setopt($curl_circle, CURLOPT_TIMEOUT, 60);
    curl_setopt($curl_circle, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($curl_circle, CURLOPT_SSL_VERIFYPEER, false);
    $data_circle = curl_exec($curl_circle);
    curl_close($curl_circle);
    fclose($fp_circle);

    $new_data_circle = file_get_contents(POST_DIR . "circle_locations_new.json");
    if ( json_decode($new_data_circle) ) {
      rename(POST_DIR . "circle_locations_new.json", POST_DIR . "circle_locations.json");
      self::log('Locations updated.', false);
    } else {
      self::log('Failed.', false);
    }
  }

  public static function log($message, $show_date = true, $next_same_line = false)
  {
    $message = ($show_date) ? current_time('Y-m-d H:i:s') . ' ' . $message : $message;
    $message = ($next_same_line) ? $message . ' ' : $message . PHP_EOL;

    file_put_contents(POST_DIR . 'var/logs/cronjob.log', $message, FILE_APPEND);
  }
}
