<?php
class Post_Debug {
	public static $_debug_dir = POST_DIR . 'var/debug/';

	public static function debug_write($message, $type = '') {
		$settings = get_option(Post_Core::get_configs('settings_key'));
		if (isset($settings['debug_mode']) && $settings['debug_mode'] === 'yes') {
			Post_Core::add_required_directories();

			date_default_timezone_set('Europe/Riga'); //Change timezones so script shows correct time
			$time = date("Y-m-d H:i:s", time());
			$file_name = 'ekis_' . date("Y-m-d", time()) . '.log';
			$file = fopen(self::$_debug_dir . $file_name, 'a');

			fwrite($file, $time . PHP_EOL);
			if ($type) {
				fwrite($file, '===== ' . $type . ' =====' . PHP_EOL);
			}
			fwrite($file, print_r($message, true));
			fwrite($file, PHP_EOL);
			fclose($file);
		}
		return;
	}

	public static function get_all_files() {
		$files = array();
		$debug_params = Post_Core::get_configs('debug');
		self::delete_old_files($debug_params['delete_after']);
		$dir = new DirectoryIterator(self::$_debug_dir);
		foreach($dir as $f) {
			if (pathinfo( $f->getFilename(), PATHINFO_EXTENSION ) == 'log') {
				$name = $f->getBasename('.log');
				$date = explode('_', $name)[1] ?? '';
				$files[] = array(
					'name' => $f->getBasename(),
					'day' => $date,
				);
			}
		}

		return $files;
	}

	private static function delete_old_files($older_than) {
		$dir = new DirectoryIterator(self::$_debug_dir);
		foreach($dir as $f) {
			if (pathinfo( $f->getFilename(), PATHINFO_EXTENSION ) == 'log') {
				$name = $f->getBasename('.log');
				$date = explode('_', $name)[1] ?? '';
				$dstamp = $date ? strtotime($date) : $f->getCTime();
				if ($dstamp < strtotime('-' . $older_than . ' days')) {
					unlink($f->getPathname());
				}
			}
		}
	}
}
