<?php
class Post_Frontend
{
  public static function add_logo_to_method($label, $method)
  {
    $settings = Post_Core::get_settings();
    $image = '';

    if ( isset($settings['show_logo']) && $settings['show_logo'] === 'yes' ) {
      $image = '<img src="' . POST_URL . 'assets/img/post_logo_s.png" alt="Post"/>';
    }

    if ( $method->method_id === 'post' ) {
      $label = $image . $label;
    }
    
    return $label;
  }

  public static function change_methods_position($rates, $package)
  {
    if ( ! $rates )  return;

    $settings = Post_Core::get_settings();
    $replaced_key = "_%02d";

    if ( empty($settings['position']) ) return $rates;
    if ( empty(json_decode($settings['position'])) ) return $rates;

    $new_rates = array();
    $positions = json_decode($settings['position']);
    $new_positions = array();

    foreach ( $positions as $position_key => $position ) {
      $rate_key = 'post_' . $position_key;
      foreach($rates as $r_key => $rate){
        if(str_contains($r_key, $rate_key)){
          $position = ($position > 0) ? $position - 1 : 0;
          while ( isset($new_positions[sprintf($replaced_key, $position)]) ) {
            $position++;
          }
          $position = sprintf($replaced_key, $position);
          $new_positions[$position] = $r_key;
        }
      }
    }

    $current_position = 0;
    foreach ( $rates as $rate_key => $rate ) {
      if ( ! in_array($rate_key, $new_positions) ) {
        for ( $i = 0; $i <= $current_position + 1; $i++) {
          if ( ! isset($new_positions[sprintf($replaced_key, $i)]) ) {
            $new_positions[sprintf($replaced_key, $i)] = $rate_key;
            break;
          }
        }
      }
      $current_position++;
    }
    ksort($new_positions);

    foreach ( $new_positions as $rate_key ) {
      $new_rates[$rate_key] = $rates[$rate_key];
    }
    foreach ( $rates as $rate_key => $rate ) {
      $new_rates[$rate_key] = $rate;
    }
    return $new_rates;
  }
}
