<?php
class Post_Helper {
	public static function get_methods_asociations() {
		$asociations = array();
		$shipping_methods = Post_Core::get_configs('method_params');
		foreach ($shipping_methods as $method_name => $method_params) {
			if (!isset($method_params['key']) || !$method_params['is_shipping_method']) continue;
			if ($method_name === 'terminal') $method_name = 'pickup'; //Fix old value

			$asociations[$method_params['key']] = $method_name;
		}
		return $asociations;
	}

	public static function get_allowed_methods($set_name) {
		$configs = Post_Core::get_configs();

		if (!isset($configs['shipping_sets'][$set_name])) {
			return array('status' => 'error', 'error_code' => '003');
		}

		$allowed_methods = array();
		foreach ($configs['shipping_sets'][$set_name] as $combination => $service) {
			if ($combination === 'courier_call') continue;
			$exploded = explode(' ', $combination);
			if (!isset($exploded[1])) continue;
			if (!in_array($exploded[1], $allowed_methods)) {
				$allowed_methods[] = $exploded[1];
			}
		}
		return $allowed_methods;
	}

	public static function add_msg($msg, $type) {
		if (!session_id()) {
			session_start();
		}
		if (!isset($_SESSION['post_notices'])) {
			$_SESSION['post_notices'] = array();
		}
		$_SESSION['post_notices'][] = array('msg' => $msg, 'type' => $type);
	}

	public static function get_formated_time($value, $value_if_not) {
		if (!preg_match("/^(?:2[0-3]|[01][0-9]):[0-5][0-9]$/", $value)) {
			if ((string)(int)$value === $value || is_int($value)) {
				return $value . ':00';
			} else {
				return $value_if_not;
			}
		}

		return $value;
	}

	public static function convert_method_name_to_short($asociations, $method_name, $reverse = false) {
		foreach ($asociations as $key => $value) {
			if (!$reverse) {
				if ($method_name === $value) {
					return $key;
				}
			} else {
				if ($method_name === $key) {
					return $value;
				}
			}
		}

		return $method_name;
	}
}
