<?php
if ( ! defined('ABSPATH') ) {
  exit; // Exit if accessed directly
}

// Prepare
$shipping_settings = Post_Core::get_settings();
$configs = Post_Core::get_configs();
$page_params = Post_Manifest::page_params();

$orders_data = Post_Manifest::page_get_orders();
$selected_orders = array();
if ( isset($_COOKIE['post_checked']) ) {
  $cookie_value = json_decode(stripslashes($_COOKIE['post_checked']));
  if (is_array($cookie_value)) {
    $selected_orders = $cookie_value;
  }
}
$manifest_enabled = (!isset($shipping_settings['manifest_enable']) || $shipping_settings['manifest_enable'] === 'yes') ? true : false;

// Append custom css and js
do_action('post_admin_manifest_head');
?>

<div class="wrap page-post_manifest">
  <h1><?php _e('Expresspasts shipping', 'post'); ?></h1>
      <?php if(isset($_GET['label'])){$wc_order = wc_get_order((int) $_GET['label']);
       foreach ($wc_order->get_items() as $item_id => $item ) {
        foreach ($wc_order->get_items('shipping') as $items_id => $items ) {
        $shipping_method = $items->get_method_id();
      }
        if($item->get_product()->get_weight() == '' && $shipping_method !== 'post'){
      echo $error = '<div class="error"><p>Order #'.$_GET['label'].' Product '.$item->get_name() . ' - ' . __('Pakas satura svars nevar būt tukšs', 'post').'</p></div>';
};
if('LT' == $wc_order->get_shipping_country()){
        if((strlen($wc_order->get_billing_phone()) == 9 && substr($wc_order->get_billing_phone(),0,2) == '86') || (strlen($wc_order->get_billing_phone()) == 11 && substr($wc_order->get_billing_phone(),0,4) == '3706')){
        }else{
          echo $error = '<div class="error"><p>Order #'.$_GET['label'].' Tālruņa numurs neatbilst formātam 3706xxxxxxx vai 86xxxxxxx</p></div>';
        }
      }
  };
};?>
      <div class="call-courier-container">
        <button id="post-call-btn" class="button action"><?php _e('Call Post courier', 'post') ?></button>
      </div>

      <ul class="nav nav-tabs">
        <?php foreach ( $page_params['strings'] as $tab => $tab_title ) : ?>
          <li class="nav-item">
            <a class="nav-link <?php echo $orders_data['action'] == $tab ? 'active' : ''; ?>" href="<?php echo Post_Manifest::page_make_link(array('paged' => ($orders_data['action'] == $tab ? $orders_data['paged'] : 1), 'action' => $tab)); ?>"><?php echo $tab_title; ?></a>
          </li>
        <?php endforeach; ?>
      </ul>

      <?php if ( $orders_data['links'] ) : ?>
        <div class="tablenav">
          <div class="tablenav-pages">
            <?php echo $orders_data['links']; ?>
          </div>
        </div>
      <?php endif; ?>
      <?php if ( $orders_data['is_orders'] ) : ?>
        <div class="mass-print-container">
          <form id="manifest-print-form" action="admin-post.php" method="GET" target="">
            <input type="hidden" name="action" value="post_manifest" />
            <?php wp_nonce_field('post_manifest', 'post_manifest_nonce'); ?>
          </form>
          <form id="labels-print-form" action="admin-post.php" method="GET" target="">
            <input type="hidden" name="action" value="post_labels" /> 
            <?php wp_nonce_field('post_labels', 'post_labels_nonce'); ?>
          </form>
          <?php $desc = ''; ?>
          <div id="selected-orders" class="selected-orders <?php echo ($desc) ? 'has-desc' : ''; ?>" style="<?php echo (empty($selected_orders)) ? 'display:none' : ''; ?>">
            <span class="title"><?php echo __('Selected', 'post'); ?><?php echo ($desc) ? '*' : ''; ?>:</span>
            <?php foreach ($selected_orders as $order_id) : ?>
              <span class="item" data-id="<?php echo $order_id; ?>"><?php echo '#' . $order_id; ?><span class="dashicons dashicons-no"></span></span>
            <?php endforeach; ?>
            <?php if ($desc) : ?>
              <span class="desc">*<?php echo $desc; ?></span>
            <?php endif; ?>
          </div>
          <?php if ($manifest_enabled) : ?>
            <button id="submit_manifest_items_1" title="<?php echo __('Generate manifest', 'post'); ?>" type="button" class="button action">
              <?php echo __('Generate manifest', 'post'); ?>
            </button>
          <?php endif; ?>
          <button id="submit_manifest_labels_1" title="<?php echo __('Print labels', 'post'); ?>" type="button" class="button action">
            <?php echo __('Print labels', 'post'); ?>
          </button>
        </div>
      <?php endif; ?>

      <div class="table-container">
        <form id="filter-form" class="" action="<?php echo Post_Manifest::page_make_link(array('action' => $orders_data['action'])); ?>" method="POST">
          <?php wp_nonce_field('post_labels', 'post_labels_nonce'); ?>
          <table class="wp-list-table widefat fixed striped posts">
            <thead>

              <tr class="post-filter">
                <td class="manage-column column-cb check-column"><input type="checkbox" class="check-all" /></td>
                <th class="manage-column column-order_id">
                  <input type="text" class="d-inline" name="filter_id" id="filter_id" value="<?php echo $orders_data['filters']['id']; ?>" placeholder="<?php echo __('ID', 'post'); ?>" aria-label="Order ID filter">
                </th>
                <th class="manage-column">
                  <input type="text" class="d-inline" name="filter_customer" id="filter_customer" value="<?php echo $orders_data['filters']['customer']; ?>" placeholder="<?php echo __('Customer', 'post'); ?>" aria-label="Order ID filter">
                </th>
                <th class="column-order_status">
                  <select class="d-inline" name="filter_status" id="filter_status" aria-label="Order status filter">
                    <option value="-1" selected><?php echo _x('All', 'All status', 'post'); ?></option>
                    <?php foreach ( $orders_data['statuses'] as $status_key => $status ) : ?>
                      <option value="<?php echo $status_key; ?>" <?php echo ($status_key == $orders_data['filters']['status'] ? 'selected' : ''); ?>><?php echo $status; ?></option>
                    <?php endforeach; ?>
                  </select>
                </th>
                <th class="column-order_date">
                </th>
                <th class="manage-column">
                </th>
                <th class="manage-column">
                  <input type="text" class="d-inline" name="filter_barcode" id="filter_barcode" value="<?php echo $orders_data['filters']['barcode']; ?>" placeholder="<?php echo __('Barcode', 'post'); ?>" aria-label="Order barcode filter">
                </th>
                <?php if ($manifest_enabled) : ?>
                  <th class="column-manifest_date">
                    <div class='datetimepicker'>
                      <div>
                        <input name="filter_start_date" type='text' class="" id='datetimepicker1' data-date-format="YYYY-MM-DD" value="<?php echo $orders_data['filters']['start_date']; ?>" placeholder="<?php echo __('From', 'post'); ?>" autocomplete="off" />
                      </div>
                      <div>
                        <input name="filter_end_date" type='text' class="" id='datetimepicker2' data-date-format="YYYY-MM-DD" value="<?php echo $orders_data['filters']['end_date']; ?>" placeholder="<?php echo __('To', 'post'); ?>" autocomplete="off" />
                      </div>
                    </div>
                  </th>
                <?php endif; ?>
                <th class="manage-column">
                  <div class="post-action-buttons-container">
                    <button class="button action" type="submit"><?php echo __('Filter', 'post'); ?></button>
                    <button id="clear_filter_btn" class="button action" type="submit"><?php echo __('Reset', 'post'); ?></button>
                  </div>
                </th>
              </tr>

              <tr class="table-header">
                <td class="manage-column column-cb check-column"></td>
                <th scope="col" class="column-order_id"><?php echo __('ID', 'post'); ?></th>
                <th scope="col" class="manage-column"><?php echo __('Customer', 'post'); ?></th>
                <th scope="col" class="column-order_status"><?php echo __('Order Status', 'post'); ?></th>
                <th scope="col" class="column-order_date"><?php echo __('Order Date', 'post'); ?></th>
                <th scope="col" class="manage-column"><?php echo __('Service', 'post'); ?></th>
                <th scope="col" class="manage-column"><?php echo __('Barcode', 'post'); ?></th>
                <?php if ($manifest_enabled) : ?>
                  <th scope="col" class="column-manifest_date"><?php echo __('Manifest date', 'post'); ?></th>
                <?php endif; ?>
                <th scope="col" class="manage-column"><?php echo __('Actions', 'post'); ?></th>
              </tr>

            </thead>
            <tbody>
              <?php $date_tracker = false; ?>
              <?php foreach ( $orders_data['orders'] as $order ) : ?>
                <?php
                $barcode = $order->get_meta($configs['meta_keys']['barcode']);
                $manifest_date = $order->get_meta($configs['meta_keys']['manifest_date']);
                $date = date('Y-m-d H:i', strtotime($manifest_date));
                $manifest_date_old = $order->get_meta($configs['meta_keys']['manifest_date_old']); // Compatible with old
                $date_old = date('Y-m-d H:i', strtotime($manifest_date_old));
                foreach ($order->get_items() as $item_id => $item1 ) {
                                  $errors = array();

                  foreach ($order->get_items('shipping') as $items_id => $items1 ) {
                    $shipping_method1 = $items1->get_method_id();
                    if($item1->get_product()->get_weight() == '' && $shipping_method1 == 'post_c'){
                      $errors[] = '1';
                    }
                  }              
                  
                };
                $errors = count($errors);
                 if('LT' == $order->get_shipping_country() || substr($barcode,0,2) == 'BE'){
                    if((strlen($order->get_billing_phone()) == 9 && substr($order->get_billing_phone(),0,2) == '86') || (strlen($order->get_billing_phone()) == 11 && substr($order->get_billing_phone(),0,4) == '3706')){
                    }else{
                      $errors = '1';
                    }
                  };


                ?>
                <?php if ( $orders_data['action'] == 'completed_orders' && $date_tracker !== $date && $date_tracker !== $date_old ) : ?>
                  <tr>
                    <?php $colspan = ($manifest_enabled) ? 9 : 8; ?>
                    <td colspan="<?php echo $colspan; ?>" class="manifest-date-title">
                      <?php echo $date_tracker = $date; ?>
                    </td>
                  </tr>
                <?php endif; ?>
                <tr class="data-row">
                  <?php $checked = (in_array($order->get_id(), $selected_orders)) ? 'checked' : ''; ?>
                  <th scope="row" class="check-column"><input type="checkbox" name="items[]" class="manifest-item" value="<?php echo $order->get_id(); ?>" <?php echo $checked; ?>/></th>
                  <td class="manage-column column-order_id">
                    <a href="<?php echo $order->get_edit_order_url(); ?>">#<?php echo $order->get_order_number(); ?></a>
                  </td>
                  <td class="column-order_number">
                    <div class="data-grid-cell-content">
                    	<?php echo $order->get_billing_first_name() . ' ' . $order->get_billing_last_name(); ?>
                    </div>
                  </td>
                  <td class="column-order_status">
                    <div class="data-grid-cell-content">
                      <?php echo wc_get_order_status_name($order->get_status()); ?>
                    </div>
                  </td>
                  <td class="column-order_date">
                    <div class="data-grid-cell-content">
                      <?php echo $order->get_date_created()->format ('Y-m-d H:i:s'); ?>
                    </div>
                  </td>
                  <td class="manage-column">
                    <div class="data-grid-cell-content"> 
                      <?php Post_Order::admin_order_display($order, false); ?>
                    </div>
                  </td>
                  <td class="manage-column">
                    <div class="data-grid-cell-content">
                      <?php if ( $barcode ) : ?>
						<?= $barcode; ?>
                      <?php endif; ?>
                      <?php $error = $order->get_meta($configs['meta_keys']['error']);?>
                      <?php if ( $error ) : ?>
                        <?php if ( $barcode ) : ?><br /><?php endif; ?>
                        <span><?php echo '<b>' . __('Error', 'post') . ':</b> ' . $error; ?></span>
                      <?php endif; ?>
                    </div> 
                  </td>
                  <?php if ($manifest_enabled) : ?>
                    <td class="column-manifest_date">
                      <div class="data-grid-cell-content">
                        <?php echo $manifest_date . $manifest_date_old; ?>
                      </div>
                    </td>
                  <?php endif; ?>
                  <td class="manage-column">
                    <?php if($errors > 0){
                        $link = 'admin.php?page=post-manifest&label='.$order->get_id();
                        $target = '';
                     }else{
                        $link = 'admin-post.php?action=post_labels&post='.$order->get_id();
                        $target = 'target=""';
                     };

                    if($errors == 0){
                      if('LT' == $order->get_shipping_country() && (strlen(preg_replace('/[^0-9]/', '', $order->get_shipping_postcode())) <= 4) &&  $order->get_meta('_post_method') == 'post_c'){
                          if($errors == 0){
                            $link = 'admin.php?page=post-manifest&label='.$order->get_id();
                            $target = '';
                          }
                       }elseif('LT' == $order->get_shipping_country() && (strlen(preg_replace('/[^0-9]/', '', $order->get_shipping_postcode())) <= 4) &&  $order->get_meta('_post_method') == 'post_po'){
                            $link = 'admin.php?page=post-manifest&label='.$order->get_id();
                            $target = '';
                       }else{

                          $link = 'admin-post.php?action=post_labels&post='.$order->get_id();
                          $target = 'target=""';
                       };
                     }?>

                    <a href="<?php echo $link;?>" <?php echo $target;?> class="button action">
                      <?php echo _x('Print label', 'button', 'post'); ?>
                    </a>
                    <?php if ( $barcode && !$manifest_date) : ?>
                      <a href="<?php echo $link;?>&process=regenerate"  <?php echo $target;?> class="button action">
                        <?php echo _x('Regenerate', 'button', 'post'); ?>
                      </a> 
                    <?php endif; ?>
                  </td>
                </tr>
              <?php endforeach; ?>

              <?php if ( ! $orders_data['orders'] ) : ?>
                <tr>
                  <td colspan="9">
                    <?php echo __('No orders found', 'woocommerce'); ?>
                  </td>
                </tr>
              <?php endif; ?>
            </tbody>
          </table>
        </form>
      </div>

      <?php if ( $orders_data['is_orders'] ) : ?>
        <div class="mass-print-container">
          <?php if ($manifest_enabled) : ?>
            <button id="submit_manifest_items_2" title="<?php echo __('Generate manifest', 'post'); ?>" type="button" class="button action">
              <?php echo __('Generate manifest', 'post'); ?>
            </button>
          <?php endif; ?>
          <button id="submit_manifest_labels_2" title="<?php echo __('Print labels', 'post'); ?>" type="button" class="button action">
            <?php echo __('Print labels', 'post'); ?>
          </button>
        </div>
      <?php endif; ?>

      <!-- Modal Courier call-->
      <div id="post-courier-modal" class="modal" role="dialog">
        <!-- Modal content-->
        <div class="modal-content">
          <div class="alert-info">
            <p><span><?php _e('Important!', 'post') ?></span> <?php _e('Latest call for same day pickup is until 3 pm.', 'post') ?></p>
            <p><?php _e('Address and contact information can be changed in post settings.', 'post') ?></p>
          </div>
          <form id="post-call" action="admin-post.php" method="GET">
            <input type="hidden" name="action" value="post_call_courier" />
            <?php wp_nonce_field('post_call_courier', 'post_call_courier_nonce'); ?>
            <div><span><?php echo __("Shop name", 'post'); ?>:</span> <?php echo $shipping_settings['shop_name']; ?></div>
            <div><span><?php echo __("Shop phone number", 'post'); ?>:</span> <?php echo $shipping_settings['shop_phone']; ?></div>
            <div><span><?php echo __("Shop postcode", 'post'); ?>:</span> <?php echo $shipping_settings['shop_postcode']; ?></div>
            <div>
              <span><?php echo __("Shop address", 'post'); ?>:</span> <?php echo $shipping_settings['shop_address'] . ', ' . $shipping_settings['shop_city']; ?>
            </div>
            <div>
              <span><?php echo __("Number of parcels", 'post'); ?>:</span>
              <input type="number" id="call_quantity" name="call_quantity" min="0" max="29" step="1" value="<?php echo count($selected_orders); ?>"/>
            </div>
            <div class="modal-footer">
              <button type="submit" id="post-call-confirm-btn" class="button action"><?php _e('Call post courier', 'post') ?></button>
              <button type="button" id="post-call-cancel-btn" class="button action"><?php _e('Cancel') ?></button>
            </div>
          </form>
        </div>
      </div>
      <!--/ Modal Carier call-->

      <script>
        jQuery('document').ready(function($) {
          // "From" date picker
          $('#datetimepicker1').datetimepicker({
            pickTime: false,
            useCurrent: false
          });
          // "To" date picker
          $('#datetimepicker2').datetimepicker({
            pickTime: false,
            useCurrent: false
          });

          // Set limits depending on date picker selections
          $("#datetimepicker1").on("dp.change", function(e) {
            $('#datetimepicker2').data("DateTimePicker").setMinDate(e.date);
          });
          $("#datetimepicker2").on("dp.change", function(e) {
            $('#datetimepicker1').data("DateTimePicker").setMaxDate(e.date);
          });

          // Pass on filters to pagination links
          $('.tablenav-pages').on('click', 'a', function(e) {
            e.preventDefault();
            var form = document.getElementById('filter-form');
            form.action = e.target.href;
            form.submit();
          });

          // Filter cleanup and page reload
          $('#clear_filter_btn').on('click', function(e) {
            e.preventDefault();
            $('#filter_id, #filter_customer, #filter_barcode, #datetimepicker1, #datetimepicker2').val('');
            $('#filter_status').val('-1');
            document.getElementById('filter-form').submit();
          });
        });
      </script>
</div>
