(function($) {
  /* Checkbox events */
  $(document).on('click', '.check-all', function() {
    var checked = $(this).prop('checked');
    $(this).parents('table').find('.manifest-item').each(function() {
      $(this).prop('checked', checked);
      manspasts_update_checked_list(this);
    });
  });
  $(document).on('change','input.manifest-item', function() {
    $("#call_quantity").val($('input.manifest-item:checkbox:checked').length);
    $("#call_quantity").trigger("change");
    manspasts_update_checked_list(this);
  });
  $(document).on('change','input.check-all', function() {
    $("#call_quantity").val($('input.manifest-item:checkbox:checked').length);
    $("#call_quantity").trigger("change");
  });

  /* Selected list */
  $(document).on('click', '#selected-orders .item', function() {
    var value = $(this).attr("data-id");
    if (value) {
      var checkbox = $('input.manifest-item[value="' + value + '"]');
      if (checkbox.length) {
        $(checkbox).prop('checked', false);
        $(checkbox).trigger('change');
      } else {
        manspasts_remove_from_checked_list(value);
      }
      manspasts_remove_selected_item(this);
    }
  });

  /* Call courier */
  $(document).on('click', '#manspasts-courier-modal', function(e) {
    if (e.target === this) {
      $('#manspasts-courier-modal').removeClass('open');
    }
  });

  $(document).on('click', '#manspasts-call-btn', function(e) {
    e.preventDefault();
    $('#manspasts-courier-modal').addClass('open');
    $("#call_quantity").trigger("change");
  });

  $(document).on('click', '#manspasts-call-cancel-btn', function(e) {
    e.preventDefault();
    $('#manspasts-courier-modal').removeClass('open');
  });

  $(document).on('change', '#call_quantity', function(e){
    var min=parseFloat($(this).attr('min'));
    var max=parseFloat($(this).attr('max'));
    var curr=parseFloat($(this).val());
    if (curr > max) { $(this).val(max); }
    if (curr < min) { $(this).val(min); }

    if (curr <= 0) {
      $('#manspasts-call-confirm-btn').prop('disabled', true);
    } else {
      $('#manspasts-call-confirm-btn').prop('disabled', false);
    }
  });

  /* Submit buttons */
  $(document).on('click', '#submit_manifest_labels_1, #submit_manifest_labels_2', function() {
    manspasts_submit_bulk_action('#labels-print-form');
  });

  $(document).on('click', '#submit_manifest_items_1, #submit_manifest_items_2', function() {
    manspasts_submit_bulk_action('#manifest-print-form');
  });

  /* Functions */
  function manspasts_update_checked_list(checkbox) {
    var value = $(checkbox).val();
    var cookie_value = [];

    if ($(checkbox).is(':checked')) {
      manspasts_add_to_checked_list(value);
    } else {
      manspasts_remove_from_checked_list(value);
    }
  }

  function manspasts_add_to_checked_list(value) {
    var cookie_value = [];
    if (manspasts_getCookie(manspastsglobals.cookie_checked_list) == null) {
      $('#selected-orders').show();
      cookie_value = [value];
      manspasts_add_selected_item(value);
    } else {
      var current_cookie = manspasts_getCookie(manspastsglobals.cookie_checked_list);
      cookie_value = JSON.parse(current_cookie);
      if (!cookie_value.includes(value)) {
        cookie_value.push(value);
        manspasts_add_selected_item(value);
      }
    }
    manspasts_setCookie(manspastsglobals.cookie_checked_list, JSON.stringify(cookie_value), 12*60);
  }

  function manspasts_remove_from_checked_list(value) {
    var cookie_value = [];
    if (manspasts_getCookie(manspastsglobals.cookie_checked_list) != null) {
      var current_cookie = manspasts_getCookie(manspastsglobals.cookie_checked_list);
      cookie_value = JSON.parse(current_cookie);
      for (var i=0;i<cookie_value.length;i++) {
        if (cookie_value[i] == value) {
          cookie_value.splice(i, 1);
        }
      }
      if (cookie_value.length == 0) {
        manspasts_eraseCookie(manspastsglobals.cookie_checked_list);
        setTimeout(function() {
          $('#selected-orders').hide();
        }, 600);
      } else {
        manspasts_setCookie(manspastsglobals.cookie_checked_list, JSON.stringify(cookie_value), 12*60);
      }

      manspasts_remove_selected_item($('#selected-orders .item[data-id="' + value + '"]'));
    }
  }

  function manspasts_add_selected_item(value) {
    var element = $('<span class="item" data-id="' + value + '">#' + value + '<span class="dashicons dashicons-no"></span></span>');
    element.appendTo('#selected-orders');
    element.addClass('adding');
    setTimeout(function() {
      $(element).removeClass('adding');
    }, 600);
  }

  function manspasts_remove_selected_item(element) {
    $(element).addClass('removing');
    setTimeout(function() {
      $(element).remove();
    }, 600);
  }

  function manspasts_submit_bulk_action(form_selector) {
    var ids = [];
    $(form_selector + ' .post_id').remove();
    if (manspasts_getCookie(manspastsglobals.cookie_checked_list) != null) {
      var current_cookie = manspasts_getCookie(manspastsglobals.cookie_checked_list);
      ids = JSON.parse(current_cookie);
    }
    $('.manifest-item:checked').each(function() {
      var id = $(this).val();
      if (!ids.includes(id)) {
        ids.push(id);
      }
    });
    for (var i=0; i<ids.length; i++) {
      $(form_selector).append('<input type="hidden" class = "post_id" name="post[]" value = "' + ids[i] + '" />');
    }
    if (!ids.length) {
      alert(manspaststext.alert_select_orders);
    } else {
      manspasts_eraseCookie(manspastsglobals.cookie_checked_list);
      $('#selected-orders .item').remove();
      $('#selected-orders').hide();
      $('.manifest-item').prop('checked', false);
      $('.check-all').prop('checked', false);
      $(form_selector).submit();
    }
  }
})(jQuery);
