<?php
class Manspasts_Helper {
	public static function get_methods_asociations() {
		$asociations = array();
		$shipping_methods = Manspasts_Core::get_configs('method_params');
		foreach ($shipping_methods as $method_name => $method_params) {
			if (!isset($method_params['key']) || !$method_params['is_shipping_method']) continue;
			if ($method_name === 'manspasts') $method_name = 'manspasts_plus'; //Fix old value

			$asociations[$method_params['key']] = $method_name;
		}
		return $asociations;
	}

	public static function add_msg($msg, $type) {
		if (!session_id()) {
			session_start();
		}
		if (!isset($_SESSION['manspasts_notices'])) {
			$_SESSION['manspasts_notices'] = array();
		}
		$_SESSION['manspasts_notices'][] = array('msg' => $msg, 'type' => $type);
	}

	public static function get_formated_time($value, $value_if_not) {
		if (!preg_match("/^(?:2[0-3]|[01][0-9]):[0-5][0-9]$/", $value)) {
			if ((string)(int)$value === $value || is_int($value)) {
				return $value . ':00';
			} else {
				return $value_if_not;
			}
		}

		return $value;
	}

	public static function convert_method_name_to_short($asociations, $method_name, $reverse = false) {
		foreach ($asociations as $key => $value) {
			if (!$reverse) {
				if ($method_name === $value) {
					return $key;
				}
			} else {
				if ($method_name === $key) {
					return $value;
				}
			}
		}

		return $method_name;
	}
}
