<?php
class Manspasts_Terminals
{
  public static function add_terminal_to_session()
  {
    if (isset($_POST['terminal_id']) && is_numeric($_POST['terminal_id'])) {
      WC()->session->set('manspasts_terminal_id', $_POST['terminal_id']);
    }
    wp_die();
  }

  public static function get_terminals_list($country = "ALL", $get_list = 'terminal') {
   echo $country; $terminals = self::read_terminals_file();
    if ( $get_list === 'manspasts') {
    }
    if ($get_list === 'circle' ) {
      
    }
    $grouped_options = array();
    if ( is_array($terminals) ) {
      $type = 0;

      foreach ( $terminals as $terminal ) {
        //if ($terminal['A0_NAME'] != $country && $country != "ALL") continue;
        if(isset($terminal['postal_code'])){
          $country =  substr($terminal['postal_code'],0,2);
        }elseif(isset($terminal['code'])){
          $country =  substr($terminal['code'],0,2);
        }
        if($terminal['area']){
          $nov = $terminal['area'];
        }elseif(!$terminal['area'] && !$terminal['region']){
          $nov = $terminal['city'];
        }elseif(!$terminal['area']){
          $nov = explode(' ',trim($terminal['region']))[0].' nov.'; 
        }
        if(isset($terminal['title'])){
          $title =$terminal['title'];
        }else{
          $title =$terminal['label'];
        }
        if(isset($terminal['id'])){
            $id = $terminal['id'];
          }else{
            $id = $terminal['code'];
          }
        $grouped_options[$country][$nov][$id] = $title;
      }
    }
    $grouped_options = self::sort_terminals_list($grouped_options);
    return $grouped_options;
  }

  public static function get_terminals_options($selected = '', $country = "ALL", $get_list = 'terminals')
  {
    $terminals = self::read_terminals_file();
    $parcel_terminals = '';
    
    $list_options = array(
      'list' => 'terminal',
      'type' => 0,
      'txt_select' => __('Select parcel terminal', 'manspasts'),
      'txt_show_map' => __('Show parcel terminals map', 'manspasts'),
    );
      function cmp($a, $b)
      {
          if ($a["city"] == $b["city"]) {
              return 0;
          }
          return ($a["city"] < $b["city"]) ? -1 : 1;
      }
    if ( $get_list === 'manspasts') {
      $list_options['list'] = 'manspasts';
      $list_options['type'] = 1;
      $list_options['txt_select'] = __('Select post office', 'manspasts');
      $list_options['txt_show_map'] = __('Show post offices map', 'manspasts');
    }
    if ($get_list === 'circle' ) {
      $terminals = self::read_terminals_file2();

      $list_options['list'] = 'circle';
      $list_options['type'] = '';
      $list_options['txt_select'] = __('Select post office', 'manspasts');
      $list_options['txt_show_map'] = __('Show post offices map', 'manspasts');
    }
      usort($terminals,'cmp');

    if ( is_array($terminals) ) {
      $grouped_options = array();
      foreach ( $terminals as $terminal ) {
        if(isset($terminal['city'])){
        if ( (!str_contains($terminal['code'], $country) && !str_contains($terminal['postal_code'], $country) && !str_contains($terminal['address'], $country)) && $country != "ALL" ) continue;
          

          if ( ! isset($grouped_options[$terminal['city']]) ) $grouped_options[(string) $terminal['city']] = array();
          if($terminal['additional_information']){
            $label = $terminal['address'].'('.$terminal['additional_information'].')';
          }else{
            $label = $terminal['title'];
          }

          if(isset($terminal['id'])){
            $id = $terminal['id'];
          }else{
            $id = $terminal['code'];
          }
          $grouped_options[(string) $terminal['city']][(string) $id] = $label;
        }else{
          if(!isset($terminal['title']) && !isset($terminal['additional_information'])){
            $label = $terminal['label'];
          }
          if(isset($terminal['id'])){
            $id = $terminal['id'];
          }else{
            $id = $terminal['code'];
          }

          $grouped_options[$id] = $label;
        }
      }
      $counter = 0;
      if(isset($terminal['id'])){

        foreach ( $grouped_options as $city => $locs ) {
          if(is_array($locs)){
            $parcel_terminals .= '<optgroup data-id = "' . $counter . '" label = "' . $city . '">';
            
            foreach ( $locs as $key => $loc ) {
              $parcel_terminals .= '<option value = "' . $key . '" ' . ($key == $selected ? 'selected' : '') . '>' . $loc . '</option>';
            }

            $parcel_terminals .= '</optgroup>';
          }else{
            $parcel_terminals .= '<option value = "' . $city . '" ' . ($city == $selected ? 'selected' : '') . '>' . $locs . '</option>';
          }
          $counter++;
        }
      }
    }

    $nonce = wp_create_nonce("post_terminals_json_nonce");
    $manspasts_settings = get_option(Manspasts_Core::get_configs('settings_key'));
    $parcel_terminals = '<option value = "">' . $list_options['txt_select'] . '</option>' . $parcel_terminals;
    $set_autoselect = (isset($manspasts_settings['auto_select'])) ? $manspasts_settings['auto_select'] : 'yes';
    
    $script = "<script style='display:none;'>
      var postTerminals = JSON.stringify(" . json_encode(self::get_terminals_for_map('', $country, $get_list)) . ");
    </script>";
    $script .= "<script style='display:none;'>
      var post_current_country = '" . $country . "';
      var postSettings = {
        auto_select:'" . $set_autoselect . "'
      };
      
      var post_type = '" . $get_list . "';
      var post_current_terminal = '" . $selected . "';
      jQuery('document').ready(function($){        
        $('.post_terminal').post();
        $(document).trigger('post.checkpostcode');
      });
      </script>";

    $button = '';

    return '<div class="terminal-container"><select class="post_terminal" name="post_terminal">' . $parcel_terminals . '</select>
      ' . $button . ' </div>' . $script;
  }

  public static function get_terminals_for_map($selected = '', $country = "LT", $get_list = 'terminal')
  {
    $shipping_params = Manspasts_Core::get_configs('shipping_params');
     $terminals = self::read_terminals_file();
    $parcel_terminals = '';
    $terminalsList = array();
    $comment_lang = (!empty($shipping_params[strtoupper($country)]['comment_lang'])) ? $shipping_params[strtoupper($country)]['comment_lang'] : 'lit';
    if ( is_array($terminals) ) {
      $type = 0;
      if ( $get_list === 'manspasts'){$terminals = self::read_terminals_file1();};
      if ( $get_list === 'circle' ){$terminals = self::read_terminals_file2();
      };
      usort($terminals,'cmp');
      foreach ( $terminals as $terminal ) {
        if(strpos('LT',$terminal['postal_code']) && $country == 'LT' || $terminal['code'] > 1000  && $country == 'LT'){
          if ( ! isset($grouped_options[$terminal['region']]) ) {
            $grouped_options[(string) $terminal['region']] = array();
          }
          $grouped_options[(string) $terminal['region']][(string) $terminal['id']] = $terminal['label'];
          if(isset($terminal['title'])){
            $title=$terminal['title'];
          }else{
            $title=$terminal['label'];
          }
          if(isset($terminal['lat'])){
            $lat=$terminal['lat'];
          }else{
            $lat=1;
          }
          if(isset($terminal['long'])){
            $long=$terminal['long'];
          }else{
            $long=1; 
          }
          if(isset($terminal['code'])){
            $zipcode = $terminal['code'];
          }else{
            $zipcode = $terminal['zipcode'];
          }
          if(isset($terminal['id'])){
            $id = $terminal['id'];
          }else{
            $id = $terminal['code'];
          }
          $terminalsList[] = [$title, $lat, $long,  $zipcode, $terminal['area'], $terminal['city'] !== 'NULL' ? $terminal['city'] : '', str_ireplace('"', '\"', $terminal['comment_' . $comment_lang]),$id];
        }else{
        if ( (!str_contains($terminal['code'], $country) && !str_contains($terminal['postal_code'], $country) && !str_contains($terminal['address'], $country)) && isset($shipping_params[$country])) {
          continue;
        } 

        if ( ! isset($grouped_options[$terminal['region']]) ) {
          $grouped_options[(string) $terminal['region']] = array();
        }
        $grouped_options[(string) $terminal['region']][(string) $terminal['zipcode']] = $terminal['label'];
        if(isset($terminal['title'])){
          $title =$terminal['title'];
        }else{
          $title =$terminal['label'];
        }
        if($terminal['business_place']){
          $title = $terminal['business_place'].' ('.$terminal['title'].')';
        }

        if(isset($terminal['lat'])){
          $lat=$terminal['lat'];
        }else{
          $lat=1;
        }
        if(isset($terminal['long'])){
          $long=$terminal['long'];
        }else{
          $long=1; 
        }
        $terminalsList[] = [$title, $lat, $long, $terminal['zipcode'], $terminal['area'], $terminal['city'] !== 'NULL' ? $terminal['city'] : '', str_ireplace('"', '\"', $terminal['comment_' . $comment_lang]),$terminal['id']];
      }
      }
    }
    return $terminalsList;
  }

  public static function get_terminal_name($terminal_code,$shipping_method_id)
  {
    $terminals = self::read_terminals_file();
    if ( $shipping_method_id === 'post_pt'){$terminals = self::read_terminals_file();};
    if ( $shipping_method_id === 'post_po'){$terminals = self::read_terminals_file1();};
      if ( $shipping_method_id === 'post_ck' ){$terminals = self::read_terminals_file2();
      };

    $parcel_terminals = ''; 
    if ( is_array($terminals) ) { 
      foreach ( $terminals as $terminal ) {
        if(isset($terminal['id'])){
          $id = $terminal['id'];
        }else{
          $id = $terminal['code'];
        }
        if ( $id == $terminal_code ) {
          if(isset($terminal['title'])){
            $title =$terminal['title'];
          }else{
            $title =$terminal['label'];
          }
          if($terminal['business_place']){
            $title = $terminal['business_place'].' ('.$terminal['title'].')';
          }
          return $title . ', ' . $terminal['city'];

        }
      }
    }
    return false;
  }

  public static function get_terminal_address($order)
  {
    $configs_meta = Manspasts_Core::get_configs('meta_keys');
    $shipping_method_id = get_post_meta($order->get_id(), '_manspasts_method', true);
    $terminal_id = get_post_meta($order->get_id(), $configs_meta['terminal_id'], true);
    $terminal_name = self::get_terminal_name($terminal_id,$shipping_method_id);
    if ( ! $terminal_name ) {
      $terminal_name  = __('Location not found!!!', 'manspasts');
    }
    
    return $terminal_name;
  }

  public static function terminals_modal()
  {
    return '
    <div id="PostModal" class="modal">
        <div class="post-modal-content">
            <div class="post-modal-header">
            <span class="close" id="terminalsModal">&times;</span>
            <h5 id="post_modal_title" style="display: inline">' . __('Post parcel terminals', 'manspasts') . '</h5>
            </div>
            <div class="post-modal-body" style="/*overflow: hidden;*/">
                <div id = "postMapContainer"></div>
                <div class="post-search-bar" >
                    <h4 id="post_modal_search" style="margin-top: 0px;">' . __('Parcel terminals addresses', 'manspasts') . '</h4>
                    <div id="post-search">
                    <form>
                    <input type = "text" placeholder = "' . __('Enter postcode', 'manspasts') . '"/>
                    <button type = "submit" id="map-search-button"></button>
                    </form>                    
                    <div class="post-autocomplete scrollbar" style = "display:none;"><ul></ul></div>
                    </div>
                    <div class = "post-back-to-list" style = "display:none;">' . __('Back', 'manspasts') . '</div>
                    <div class="found_terminals1 scrollbar" id="style-8">
                      <ul>
                      
                      </ul>
                    </div>
                </div>
            </div>
        </div>
    </div>';
  }

  public static function get_terminals_json()
  {
    if ( ! wp_verify_nonce($_REQUEST['nonce'], "post_terminals_json_nonce") ) {
      exit("Not allowed");
    }

    $terminals_json = self::generate_terminals_json($_REQUEST['q'], $_REQUEST['country']);
    echo json_encode($terminals_json);
    
    die();
  }

  private static function read_terminals_file()
  {
    $terminals_file = fopen(MANSPASTS_DIR . 'locations.json', "r");
    $terminals = fread($terminals_file, filesize(MANSPASTS_DIR . 'locations.json') + 10);
    fclose($terminals_file);
    $terminals_file_lt = fopen(MANSPASTS_DIR . 'locations_lt.json', "r");
    $terminals_lt = fread($terminals_file_lt, filesize(MANSPASTS_DIR . 'locations_lt.json') + 10);
    fclose($terminals_file_lt);
    return array_merge(json_decode($terminals, true),json_decode($terminals_lt, true));
  }
  private static function read_terminals_file1()
  {
    $terminals_file = fopen(MANSPASTS_DIR . 'locations_office.json', "r");
    $terminals = fread($terminals_file, filesize(MANSPASTS_DIR . 'locations_office.json') + 10);
    fclose($terminals_file);
    $terminals_file_lt = fopen(MANSPASTS_DIR . 'locations_office_lt.json', "r");
    $terminals_lt = fread($terminals_file_lt, filesize(MANSPASTS_DIR . 'locations_office_lt.json') + 10);
    fclose($terminals_file_lt);
    return array_merge(json_decode($terminals, true),json_decode($terminals_lt, true));
  }
  private static function read_terminals_file2()
  {
    $terminals_file = fopen(MANSPASTS_DIR . 'circle_locations.json', "r");
    $terminals = fread($terminals_file, filesize(MANSPASTS_DIR . 'circle_locations.json') + 10);
     fclose($terminals_file);
    $terminals = json_decode($terminals, true);
    usort($terminals, function ($a, $b) {
      return $a->area <=> $b->area;
    });
    return $terminals;
  }
  private static function generate_terminals_json($term = "", $country = "ALL", $get_list = 'terminal')
  {
    $c_p = false;
    if ( strlen($term) >= 4 && strlen($term) ) {
      $c_p = self::search_postcode($term, $country);
    }
    $terminals = self::read_terminals_file();
    $parcel_terminals = array();
    
    if ( is_array($terminals) ) {
      $grouped_options = array();
      $type = 0;
      if ( $get_list === 'manspasts' || $get_list === 'circle' ) $type = 1;
      foreach ( $terminals as $terminal ) {
        if ( (!str_contains($terminal['code'], $country) && !str_contains($terminal['postal_code'], $country)) && $country != "ALL" ) continue;

        if ( ! isset($grouped_options[$terminal['region']]) ) $grouped_options[(string) $terminal['area']] = array();
        $grouped_options[(string) $terminal['region']][(string) $terminal['zipcode']] = $terminal;
      }
      $counter = 0;
      foreach ( $grouped_options as $city => $locs ) {
        $group = array("text" =>  $city, "distance" => 0, "children" => array());
        $group_distance = false;
        foreach ( $locs as $key => $loc ) {
          if ( $term != "" && $c_p == false && stripos($loc['label'], $term) !== false ) {
            $group['children'][] = array("id" => $key, "text" => $loc['label'], "distance" => 0);
          } elseif ( is_array($c_p) ) {
            $distance = self::calc_distance($c_p[0], $c_p[1], $loc['Y_COORDINATE'], $loc['X_COORDINATE']);
            $group['children'][] = array("id" => $key, "text" => $loc['label'], "distance" => $distance);
            if ( $group_distance == false || $group_distance > $distance ) {
              $group_distance = $distance;
            }
          } elseif ( $term == "" ) {
            $group['children'][] = array("id" => $key, "text" => $loc['label'], "distance" => 0);
          }
        }
        $group['distance'] = $group_distance;
        if ( count($group['children']) && $c_p == false ) {
          $parcel_terminals[] = $group;
        } elseif ( count($group['children']) ) {
          $parcel_terminals = array_merge($parcel_terminals, $group['children']);
        }
        $counter++;
      }
    }
    if ( $c_p != false ) {
      usort($parcel_terminals, function ($a, $b) {
        return $b['distance'] > $a['distance'] ? -1 : 1;
      });
      return array_slice($parcel_terminals, 0, 8);
    }
    return $parcel_terminals;
  }

  private static function search_postcode($postcode, $country)
  {
    if ( $postcode == "" ) return false;
    $postcode = urlencode($postcode);
    $data = file_get_contents("http://geocode.arcgis.com/arcgis/rest/services/World/GeocodeServer/findAddressCandidates?singleLine=" . $postcode . "," . $country . "&category=&outFields=Postal&maxLocations=1&forStorage=false&f=pjson");
    if ( $data ) {
      $data = json_decode($data);
    } else {
      return false;
    }
    if ( isset($data->candidates) && count($data->candidates) ) {
      if ($data->candidates[0]->score > 90) {
        return array($data->candidates[0]->location->y, $data->candidates[0]->location->x);
      }
    }
    return false;
  }

  private static function calc_distance($latitudeFrom, $longitudeFrom, $latitudeTo, $longitudeTo, $earthRadius = 6371000)
  {
    // convert from degrees to radians
    $latFrom = deg2rad($latitudeFrom);
    $lonFrom = deg2rad($longitudeFrom);
    $latTo = deg2rad($latitudeTo);
    $lonTo = deg2rad($longitudeTo);

    $latDelta = $latTo - $latFrom;
    $lonDelta = $lonTo - $lonFrom;

    $angle = 2 * asin(sqrt(pow(sin($latDelta / 2), 2) +
      cos($latFrom) * cos($latTo) * pow(sin($lonDelta / 2), 2)));
    
    return round($angle * $earthRadius / 1000, 2);
  }

  private static function sort_terminals_list($list) 
  {
    $sorted_list = array();
    foreach ( $list as $key => $elem ) {
      ksort($elem);
      $sorted_list[$key] = $elem;
    }

    return $sorted_list;
  }
}
